export declare const configSchema: {
    $id: string;
    type: string;
    properties: {
        baseDir: {
            type: string;
        };
        projects: {
            type: string;
            items: {
                type: string;
                properties: {
                    branch: {
                        type: string;
                    };
                    package: {
                        type: string;
                    };
                    remote: {
                        type: string;
                    };
                    lerna: {
                        type: string;
                    };
                    links: {
                        type: string;
                        items: {
                            type: string;
                        };
                    };
                    types: {
                        type: string;
                        items: {
                            type: string;
                        };
                    };
                    buildCommand: {
                        type: string;
                    };
                    linkFrom: {
                        type: string;
                    };
                };
                required: string[];
            };
        };
        typeDefs: {
            type: string;
            additionalProperties: {
                type: string;
                properties: {
                    branch: {
                        type: string;
                    };
                    remote: {
                        type: string;
                    };
                    typesPath: {
                        type: string;
                    };
                };
                required: string[];
            };
        };
    };
    required: string[];
};
